void astroloop() {
  double secondsfor360 = 0;
  switch (AstroObject) {
    case 0:
      //Stars
      secondsfor360 = 86164.0916;
      break;
    case 1:
      break;
    case 2:
      break;
    case 3:
      //Stars
      secondsfor360 = 120;
      break;
  }
  Serial.println(secondsfor360);


  double AstroUpdateIntervalFLOAT = 1000000 / ((XsetupRES * stepAmountX) / secondsfor360);

  AstroUpdateInterval = (int)(AstroUpdateIntervalFLOAT + 0.5);
  Serial.print("XsetupRES:") ;
  Serial.println(XsetupRES);
  Serial.print("stepAmountX: ");
  Serial.println(stepAmountX);
  Serial.print("AstroUpdateInterval: ");
  Serial.println(AstroUpdateInterval);



  bool active = false;
  unsigned long MicrosSinceAstroStart = micros();
  static unsigned long FirstStepTime = 0;
  unsigned long currentStep = 0;
  int stepImpulsLength = 300; //length of STEP-impuls in [micros]

  unsigned long AstroExpo01timeinterval = AstroExpoTime01 + AstroExpo01delay + AstroExpoTime02 + AstroExpo02delay + AstroExpoTime03 + AstroExpo03delay;

  //Serial.println("Hallo");


  while (startAstro == true) {

    if (Serial1.available()) {

      char c = Serial1.read();
      //Serial.println("hallo");
      if (c == '#') {
        parseCommand(commandStr);
        // Serial.println(commandStr);
        commandStr = "";
      }
      else {
        commandStr += c;
      }
    }




    static unsigned long previousMicrosAstro = 0;
    static unsigned long previousMicrosHDR1 = 0;
    static unsigned long previousMicrosHDR2 = 0;
    static unsigned long previousMicrosHDR3 = 0;
    unsigned long currentMicrosAstro = micros();




    //Set motor-step HIGH
    if (currentMicrosAstro  - previousMicrosAstro >= AstroUpdateInterval ) {
      digitalWrite(Xstep, HIGH);

      digitalWrite(Ystep, HIGH);
      // Serial.println("STEP");
      if (currentStep == 0) {
        FirstStepTime = micros();

      }
      currentStep++;
    }
    //Set motor-step LOW
    if (currentMicrosAstro  - previousMicrosAstro >= AstroUpdateInterval + stepImpulsLength) {
      digitalWrite(Xstep, LOW);

      digitalWrite(Ystep, LOW);
      previousMicrosAstro = currentMicrosAstro - stepImpulsLength;
    }


    //------------------------------------------------------

    if (AstroPicCurrentRepeat == 0) {

      if (astroPicActive == true) {
        currentMicrosAstro = micros();
        unsigned long delayTime = currentMicrosAstro - FirstStepTime;

        if (delayTime > AstroStartDelay * 1000000 && active == false) {








          AstroPicCurrentRepeat++;

        }


      }
    }
    else if (astroPicActive == true && AstroPicCurrentRepeat <= (AstroPicRepete + 1)) {

      //Set motor-step LOW
      if (currentMicrosAstro  - previousMicrosHDR1 >= AstroExpoTime01 * 1000000 + AstroExpo01delay * 1000000) {
        digitalWrite(dslrTrigger, LOW);
        Serial.println("Trigger low2");
        active = false;

        previousMicrosHDR1 = currentMicrosAstro;

      }

      //Set motor-step HIGH
      if (currentMicrosAstro  - previousMicrosHDR1 >= AstroExpo01delay * 1000000 && active == false) {

        if (AstroPicCurrentRepeat <= AstroPicRepete) {
          digitalWrite(dslrTrigger, HIGH);


          Serial.println("-------");
          Serial.println("Trigger high2");

          active = true;
          myString = String(AstroPicCurrentRepeat);
          StringSend = "#currentPicNo_" + myString + "$";
          Serial1.print(StringSend);
          AstroPicCurrentRepeat++;
        }



        else {
          astroPicActive = false;
          Serial.println("falsessssss");
          StringSend = "#astroLastPic_0$";
          Serial1.print(StringSend);
        }
      }
    }
    else {}


  }
}
